<script lang="ts" setup>
import { useUserStore } from "@/stores/user";
import { onMounted, ref } from "vue";
import UserDelete from "./UserDelete.vue";
import UserDialog from "./UserDialog.vue";

const TextField = ref(false);
const userStore = useUserStore();
const backendURL = import.meta.env.VITE_BACKEND_URL;

function showTextField(){
  TextField.value = true;
}

onMounted(async () => {
  await userStore.getUsers();
});

setInterval(userStore.getUsers, 1000);
</script>
<template>
  <UserDialog></UserDialog>
  <UserDelete></UserDelete>
  <v-container fluid fill-height class="d-flex justify-center align-center">
    <v-row class="justify-center">
      <v-col>
        <v-card class="ma-5" color="#EEF2E6">
          <v-row class="justify-center">
            <v-card class="pa-5 ma-2 text-h4 text-center" width="100%" color="#1C6758" style="color: white">
              <label style="padding: 10px;">ข้อมูลพนักงาน</label>
              <v-icon color="white" @click="showTextField()">mdi-magnify</v-icon>
              <v-text-field class="input" label="ค้นหา ชื่อ-นามสกุล ตำแหน่ง พนักงาน" v-model="userStore.search" v-if="TextField"  @blur="TextField = false"></v-text-field>
            </v-card>
          </v-row>
          <v-table id="table" style="padding-top: 10px;">
            <thead>
              <tr>
                <th>ID</th>
                <th>First Name</th>
                <th>Last Name</th>
                <th>Rank</th>
                <th>Rate</th>
                <th>Gender</th>
                <th>Telephone</th>
                <th>Image</th>
                <!-- <th>Username</th> -->
                <!-- <th>Password</th> -->
                <th><v-btn size="x-large" class="btng" @click="userStore.dialog = true">
                    <v-icon>mdi-plus</v-icon>New
                  </v-btn></th>
              </tr>
            </thead>
            <tbody>
              <tr v-for="item of userStore.users" :key="item.id">
                <td>{{ item.id }}</td>
                <td>{{ item.fname }}</td>
                <td>{{ item.lname }}</td>
                <td>{{ item.type }}</td>
                <td>{{ item.rate }}฿</td>
                <td>{{ item.gender }}</td>
                <td>{{ item.tel }}</td>
                <td><v-img height="120" :src="`${backendURL}/users/image/${item.image}`"></v-img></td>
                <!-- <td>{{ item.username }}</td> -->
                <!-- <td>{{ item.password }}</td> -->
                <td class="text-center">
                  <span style="padding-right: 10px">
                    <v-btn icon round class="btno" @click="userStore.editUser(item)">
                      <v-icon>mdi-pencil</v-icon>
                    </v-btn>
                  </span>
                  <span style="padding-left: 10px"><v-btn icon round class="btnr" @click="userStore.dialogDelete(item)">
                      <v-icon>mdi-delete</v-icon>
                    </v-btn>
                  </span>
                </td>
              </tr>
            </tbody>
          </v-table>
        </v-card>
      </v-col>
    </v-row>
  </v-container>
</template>
<style scoped>
@import url("https://fonts.googleapis.com/css2?family=Noto+Sans+Thai:wght@100&display=swap");

label {
  font-family: "Noto Sans Thai", sans-serif;
  font-weight: bold;
  font-size: 40px !important;
}

.input {
  font-family: "Noto Sans Thai", sans-serif;
}

th {
  font-family: "Noto Sans Thai", sans-serif;
  font-size: 24px !important;
  text-align: center;
  font-weight: bold !important;
}

td {
  font-family: "Noto Sans Thai", sans-serif;
  font-size: 18px !important;
  font-weight: bold;
  text-align: center;
}

#table {
  border-collapse: collapse;
  width: 100%;
}

#table td,
#table th {
  padding: 10px;
  text-align: center;
}

#table th {
  padding-top: 12px;
  padding-bottom: 12px;
  text-align: center;
  background-color: #1c6758;
  color: white;

}

#table tr {
  padding-top: 12px;
  padding-bottom: 12px;
  text-align: left;
  background-color: #FFEFCF;
  color: black;
}

.btng {
  background-color: #92D050;
  font-weight: bold !important;
  font-size: 16px !important;
}

.btnr {
  background-color: #FF4A4A;
}

.btno {
  background-color: #FFC000;
}
</style>
